

/*********************************************************************
*                                                                    *
*                      Welcome to Master's 2000                      *          
*                                                                    *
**********************************************************************
*                                                                    *
*   Filename:       init.c                                           *
*   Date:           07/27/2000                                       *
*   File Version:   1.00                                             *
*                                                                    *
*   Compiler:       Hi-Tech PIC C Compiler V7.86 PL3                 *
*                                                                    *
*   Author:         Your Name                                        *
*   Company:        Your Company                                     *
*                                                                    *
**********************************************************************
*                                                                    *
*   Files required:                                                  *
*                                                                    *
*                   pic.h        (Hi-Tech file)                      *
*                                                                    *
*                                                                    *
**********************************************************************
*                                                                    *
*   Notes: The routines within this file are required for            *
*          initializing the peripherals on the PICmicro PIC16C77     *                                   *
*                                                                    *
*                                                                    *
*********************************************************************/

#include  <pic.h>                  // processor if/def file

#define FOSC (4000000L)               // define external clock frequency

//============================================================================================

/********************************
     Initialize USART Module
********************************/

void Init_Usart(void)
{
/*  
    1. Baud rate = 19200                         - SPBRG register (page 111)
    2. Enable Transmitter                        - TXSTA register (page 109)
    3. Continuous receive, serial port enabled   - RCSTA register (page 110)
*/

    SPBRG = 0x51;      			// 19200 baud @16MHz
    TXSTA = 0b00100100;                 // 8-bit TX, Enable Transmitter, BRGH=1
    RCSTA = 0b10010000;                 // Continuous receive, serial port enabled, 8-bit RX
}                                      


/*****************************************
    Initialize A/D & Comparator Module
******************************************/

void Init_Adc( void )
{
	CMCON=0b000000111;		// Analog comparator disable
	ADCON1=0b00001110;		// AN0 is A/D input
	ADFM=1;					// Right justified
	ADCON0=0b10000001; 		// Selext CH0 , A/D on
}     



/********************************
      Initialize CCP1 Module
********************************/

void Init_Pwm1( void )
{
/*  The values used to set up the PWM1 peripheral must be determined and entered in this function.

    Reference pages 70, 72, 74 and 75 of PIC16C7X Data Sheet (DS30390E)
    The 5 PWM1 setup requirements are:

    1. PWM1 Period = 15.686Khz 		              - PR2 register (page 74)
    2. PWM1 duty cycle registers = 0x00               - CCPR1L & CCPR1H
    3. Set CCP1 pin as output                         - TRISC<2>
    4. Establish PWM1 Mode                            - CCP1CON register (page 72)
    5. Enable Timer2                                  - TCON2 register (page 70)
*/

/***  Peripheral registers setup here ***/

}                                           // closing '}' generates a return instruction


/***************************
   Initialize TMR1 Module
***************************/

void Init_Timer1(void)
{
/*  The values used to set up the TMR1 peripheral must be determined and entered in this function.

    Reference pages 34, 35, and 65 in PIC16C7X Data Sheet (DS30390E)
    The 4 TMR1 setup requirements are:

    1. External clock oscillator, 1:1 Prescale        	- T1CON register (page 65)
                                               
    2. Preload TMR1H such that rollover (FFFF->0000)
       occurs at 0.5 second based on 32.768KHz oscillator

    3. Clear pending TMR1 Interrupt Flag

    4. Enable TMR1 Interrupt
       
*/

/***  Peripheral registers setup here ***/

}					     // closing '}' generates a return instruction
